// headdead_events.zs

// 12/9/21 - added universal AI

class HeadShotBonus : PowerTimeFreezer
{
	int dur;
	override void InitEffect()
	{
		int hb_bonus = CVar.FindCvar("hb_bonus").GetInt();
		dur = 35 * (hb_bonus + int(Owner.CountInv("HeadShot") * .1));
		S_PauseSound(false, false);
	}
	override void DoEffect()
	{
		if (dur)
		{
			dur--;
			Owner.A_PrintBold(String.Format("%d", int(dur/35)), 0, "Bigfont");
			if (dur % 20 == 1)
			{
				Owner.A_StartSound("hbeat", CHAN_AUTO, CHANF_OVERLAP, 1.0, ATTN_NONE);
			}
		}
		else
		{
			Powerup.EndEffect();
		}
		PowerTimeFreezer.DoEffect();
	}
}

class headdead_EventHandler : EventHandler
{
	PlayerInfo player;
	ThinkerIterator MonsterFinder;

	void headshotBonus()
	{
		player.mo.GiveInventory("HeadShotBonus", 1);
	}
	override void RenderOverlay(RenderEvent e)
	{
		bool hb_enabled = CVar.FindCvar("hb_enabled").GetBool();

		if (hb_enabled)
		{
			int row = 100;
			int col = Screen.GetWidth() - 250;
			Screen.DrawText(OriginalBigFont, Font.CR_RED, col, row, String.Format("Head Shots: %d", player.mo.CountInv("HeadShot")));
		}
	}
	void findJumpers(float distance)
	{
		Actor mo;
		MonsterFinder.Reinit();
		while (mo = Actor(MonsterFinder.Next()))
		{
			string species = mo.GetSpecies();
			if (species == "Zombieman" || species == "DoomImp" || species == "ShotgunGuy" || species == "ChaingunGuy")
			{
				if (mo.InStateSequence(mo.CurState, mo.ResolveState("See")))
				{
					if (mo.CountProximity("Box", 8, CPXF_CLOSEST | CPXF_CHECKSIGHT | CPXF_NOZ))
					{
						int z = mo.pos.z;
						mo.SetZ(z + Random(4, 8));
						mo.A_Recoil(Random(-16,-32));
						mo.SetZ(z);
					}
				}
			}
		}
	}
	override void WorldTick()
	{
		bool db_enabled = CVar.FindCvar("db_enabled").GetBool();
		if (db_enabled)
		{
			findJumpers(1024);
		}
	}

	override void WorldThingDied(WorldEvent e)
	{
		bool db_enabled = CVar.FindCvar("db_enabled").GetBool();

		if (e.thing && e.thing.health < 1 && db_enabled)
		{
			string species = e.thing.GetSpecies();
			if (species == "Zombieman" || species == "DoomImp" || species == "ShotgunGuy" || species == "ChaingunGuy")
			{
				e.thing.A_SpawnItemEx("Box", 0,0,Random(4,12),0,0,0,0, SXF_ISMASTER);
			}
		}
	}
	override void WorldThingDamaged(WorldEvent e)
	{
		bool hb_enabled = CVar.FindCvar("hb_enabled").GetBool();
		int hb_bonus = CVar.FindCvar("hb_bonus").GetInt();

		if (e.thing && e.thing.GetSpecies() == "HeadshotHitbox" && hb_enabled)
		{
			if (e.damagesource == player.mo)
			{
				e.thing.SetStateLabel("Death"); // can still headshot, just doesn't count

				int bonus = player.mo.CountInv("HeadShotBonus");
				if (bonus == 0)
				{
					player.mo.GiveInventory("HeadShot", 1);
				
					int hs = player.mo.CountInv("HeadShot");
					if (hs >= hb_bonus && hs % hb_bonus == 0)
					{
						headshotBonus();
					}
				}
			}
			else
			{
				e.thing.SetStateLabel("Spawn");

			}
		}
	}

	override void WorldThingSpawned(WorldEvent e)
	{
		bool hb_enabled = CVar.FindCvar("hb_enabled").GetBool(); // keep?
		if (e.thing)
		{
			string species = e.thing.GetSpecies();
			if (species == "Zombieman" || species == "DoomImp" || species == "ShotgunGuy" || species == "ChaingunGuy")
			{
				e.thing.height = 45;
				e.thing.scale = (1.05, 1.05);
				e.thing.A_SpawnItemEx("HeadshotHitbox", 0,0,0, 0,0,0, 0, SXF_SETMASTER);
			}
		}
	}

	override void PlayerDied(PlayerEvent e)
	{
		player.mo.TakeInventory("HeadShot", player.mo.CountInv("HeadShot"));
	}
	override void PlayerRespawned(PlayerEvent e)
	{
		player.mo.bNoTimeFreeze = true;
	}
	override void PlayerSpawned(PlayerEvent e)
	{
		player = players[e.PlayerNumber];
		player.mo.bNoTimeFreeze = true;
		MonsterFinder = ThinkerIterator.Create("Actor");
	}
}

class hbdb_OptionMenu : OptionMenu {
	override void Init(Menu parent, OptionMenuDescriptor desc) {
		super.Init(parent, desc);
		DontDim = true;
		DontBlur = true;
	}
}